<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

 /**
 * Showing IdP Setup form info.
 */
 function miniorange_saml_idp_setup($form, &$form_state) {

  if (variable_get('miniorange_saml_customer_admin_email', NULL) == NULL || variable_get('miniorange_saml_customer_id', NULL) == NULL
    || variable_get('miniorange_saml_customer_admin_token', NULL) == NULL || variable_get('miniorange_saml_customer_api_key', NULL) == NULL) {
    $form['header'] = array(
      '#markup' => '<center><h3>You need to register with miniOrange before using this module.</h3></center>',
    );

    return $form;
  }
  
  drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
  drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
   

  $form['miniorange_saml_IDP_tab'] = array(
  '#markup' => '<div id="tabhead"><h5> Enter the information gathered from your Identity Provider &nbsp; OR &nbsp;<a class="btn btn-primary btn-large" style="padding:6px 12px;" onclick="show_metadata_form()">'
    . 'Upload Metadata URL </a><br><br> </h5></div>',
  );
  
  $form['metadata_1'] = array(
	'#markup' =>'<div border="1" id="upload_metadata_form" style="background-color:#FFFFFF; border:2px solid #CCCCCC; padding:1px 1px 1px 10px; display:none;" >'
  . '		<table style="width:100%;">'
  .'		<tr> <td colspan="3">'
  .'				<h1>Upload IDP Metadata'
  .'					<span style="float:right;margin-right:25px;">'
  .'						<input type="button" class="btn btn-sm btn-danger" value="Cancel" onclick = "hide_metadata_form()"/></a><br>'
  .'					</span>',
  );
  
  $form['metadata_2'] = array(
   '#markup' => '</span>'
  .'					<br><br><hr>'
  .'				</h1>'
  .'			</td>'
  .'		</tr>'
  .'			<tr>'
  .'				<td><h4>Upload Metadata  :</h4>'
  .'				<td colspan="2">',
  );
  
  $form['metadata_file'] = array(
    '#type' => 'file',
  );
  
  $form['metadata_upload'] = array(
    '#type' => 'submit',
    '#value' => t('Upload'),
    '#submit' => array('miniorange_saml_upload_file'),
  );
  
  $form['metadata_3'] = array(
    '#markup' =>'</td></td>'
	.'	</tr>'
	.'				<tr><td colspan="3" ><p style="font-size:13pt;text-align:center;"><b>OR</b></p></td></tr>'
	.'		    <tr>'
	.'			<td width="20%"><h4>Enter metadata URL:</h4></td><td width="10%">',
  );
  
  $form['metadata_URL'] = array(
    '#type' => 'textfield',
	'#attributes' => array('placeholder' => 'Enter metadata URL of your IdP.'),
  );
  
  $form['metadata_4'] = array(
    '#markup' =>'</td><td>',
  );
	
   $form['metadata_fetch'] = array(
	'#type' => 'submit',
    '#value' => t('Fetch Metadata'),
    '#submit' => array('miniorange_saml_fetch_metadata'),
   
   );
   
   $form['metadata_5'] = array(
   '#markup' => '	</td>	</tr>'
	.'	</table>'
	.'</div>'
	.'<div id="idpdata">',
   );
   
   $form['miniorange_saml_idp_name'] = array(
    '#type' => 'textfield',
    '#title' => t('IdP Name'),
    '#default_value' => variable_get('miniorange_saml_idp_name', ''),
    '#attributes' => array('placeholder' => 'IdP Name'),
  );

  $form['miniorange_saml_idp_issuer'] = array(
    '#type' => 'textfield',
    '#title' => t('IdP Entity ID or Issuer'),
	'#description' => t('<b>Note :</b> You can find the EntityID in Your IdP-Metadata XML file enclosed in <code>EntityDescriptor</code> tag having attribute as <code>entityID</code>'),
    '#default_value' => variable_get('miniorange_saml_idp_issuer', ''),
    '#attributes' => array('placeholder' => 'Identity Provider Name like ADFS, SimpleSAML etc.'),
  );
  
  $form['miniorange_saml_sign_request'] = array(
    '#type' => 'checkbox',
    '#title' => t('Sign SAML Request  <b>[PREMIUM]</b>'),
    '#default_value' => variable_get('miniorange_saml_sign_request', FALSE),
	'#disabled' => TRUE,
  );
  
  $form['miniorange_nameid_format'] = array(
    '#type' => 'select',
    '#title' => t('NameID Format'),
    '#options' => array(
      1 => t('urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress'),
      2 => t('urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified'),
    ),
    '#default_value' => variable_get('miniorange_nameid_format'),
  );
  
  $form['miniorange_saml_idp_binding'] = array(
	'#type' => 'radios',
	'#title' => t('HTTP Binding'),
	'#default_value' => 'HTTP-Redirect',
	'#options' => array(
	t('HTTP-Redirect'),
	t('HTTP-POST <b>[PREMIUM]</b>'),),
	'#disabled' => TRUE,
  );

  $form['miniorange_saml_idp_login_url'] = array(
    '#type' => 'textfield',
    '#title' => t('SAML Login URL'),
	'#description' => t('<b>Note :</b> You can find the SAML Login URL in Your IdP-Metadata XML file enclosed in <code>SingleSignOnService</code> tag (Binding type: HTTP-Redirect)'),
	'#default_value' => variable_get('miniorange_saml_idp_login_url', ''),
    '#attributes' => array('placeholder' => 'Single Sign-On Service URL (HTTP-Redirect binding) of your IdP'),
  );
  
   $form['miniorange_saml_idp_logout_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Single Logout Service URL  [PREMIUM]'),
    '#description' => t('<b>Note :</b> You can find the SAML Login URL in Your IdP-Metadata XML file enclosed in <code>SingleLogoutService</code> tag'),
	'#attributes' => array('placeholder' => 'Single Logout Service URL'),
	'#disabled' => TRUE,
  );

  $form['miniorange_saml_idp_x509_certificate'] = array(
    '#type' => 'textarea',
    '#title' => t('x.509 Certificate Value'),
    '#cols' => '6',
    '#rows' => '5',
    '#default_value' => variable_get('miniorange_saml_idp_x509_certificate', ''),
    '#attributes' => array('placeholder' => 'Enter x509 Certificate Value'),
  );

  $form['markup_1'] = array(
    '#markup' => '<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>'
  );

  $form['markup_2'] = array(
    '#markup' => 'XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b><br><br>'
  );
  
  $form['miniorange_saml_enable_login'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable login with SAML'),
    '#default_value' => variable_get('miniorange_saml_enable_login', FALSE),
  ); 
  
  $form['miniorange_saml_test_config_button'] = array(
    '#markup' => '<a class="btn btn-primary btn-large" style="padding:6px 12px;" onclick="testConfig(\'' . getTestUrl() . '\');">'
    . 'Test Configuration</a><br><br>',
	'#prefix'=>'<td>',
    '#suffix'=>'</td>',
	'#weight'=>2,
  );

  $form['miniorange_saml_idp_config_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Configuration'),
	'#prefix'=>'<td>',
    '#suffix'=>'</td>',
	'#weight'=>1,
    '#submit' => array('miniorange_saml_save_idp_config'),
  );
  
  $form['miniorange_saml_end'] = array(
   '#markup' => '</div>',
  );

  return $form;

 }
 
 function getTestUrl() {
  global $base_url;
  $host_name = MiniorangeSAMLConstants::BASE_URL;
  $customer_key = variable_get('miniorange_saml_customer_id', '');
  $customer_token = variable_get('miniorange_saml_customer_admin_token', '');
  $url = $host_name . '/moas/idptest/?id=' . $customer_key . '&key=' . $customer_token;

  $testUrl = $base_url . '/?q=testConfig';

  return $testUrl;
 }

 /**
 * Configure IdP.
 */
 function miniorange_saml_save_idp_config($form, &$form_state) {
  global $base_url;
  $idp_name = $form['miniorange_saml_idp_name']['#value'];
  $issuer = $form['miniorange_saml_idp_issuer']['#value'];
  $nameid_format = $form['miniorange_nameid_format']['#value'];
  $login_url = $form['miniorange_saml_idp_login_url']['#value'];
  $x509_cert_value = Utilities::sanitize_certificate($form['miniorange_saml_idp_x509_certificate']['#value']);
  $enable_login = $form['miniorange_saml_enable_login']['#value'];

  if ($enable_login == 1) {
    $enable_login = TRUE;
  }
  else {
    $enable_login = FALSE;
  }
  
  if($nameid_format == 1) {
	$nameid_format = 'urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress';
  }
  else {
	$nameid_format = 'urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified';
  }

  $sp_issuer = $base_url;
  variable_set('miniorange_saml_idp_name', $idp_name);
  variable_set('miniorange_saml_sp_issuer', $sp_issuer);
  variable_set('miniorange_saml_idp_issuer', $issuer);
  variable_set('miniorange_nameid_format',$nameid_format);
  variable_set('miniorange_saml_idp_login_url', $login_url);
  variable_set('miniorange_saml_idp_x509_certificate', $x509_cert_value);
  variable_set('miniorange_saml_enable_login', $enable_login);

  drupal_set_message(t('Identity Provider Configuration successfully saved'));

 }
 
function miniorange_saml_upload_file($form, &$form_state) {
	
	$file_name = $_FILES['files']['tmp_name']['metadata_file'];
	
	$file = file_get_contents($file_name);

	upload_metadata($file);
}

function miniorange_saml_fetch_metadata($form, &$form_state) {
	$url=filter_var($form['metadata_URL']['#value'],FILTER_SANITIZE_URL);
	$file = file_get_contents($url);
	upload_metadata($file);	
}

function upload_metadata($file){
	
	require_once drupal_get_path('module', 'miniorange_saml') . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'MetadataReader.php';
	
		$document = new DOMDocument();
		$document->loadXML($file);
		restore_error_handler();
		$first_child = $document->firstChild;

		if(!empty($first_child)) {
			$metadata = new IDPMetadataReader($document);
			$identity_providers = $metadata->getIdentityProviders();
			if(empty($identity_providers)) {
				drupal_set_message(t('Please provide a valid metadata file.'),error);
			return;
			}
			
			foreach($identity_providers as $key => $idp){

				$saml_login_url = $idp->getLoginURL('HTTP-Redirect');
				
				if(empty($saml_login_url)) {
					$saml_login_url = $idp->getLoginURL('HTTP-POST');
				}
				
				$saml_issuer = $idp->getEntityID();
				$saml_x509_certificate = $idp->getSigningCertificate();
								
				 $sp_issuer = $base_url;
				  
				  variable_set('miniorange_saml_sp_issuer', $sp_issuer);
				  variable_set('miniorange_saml_idp_issuer', $saml_issuer);
				  variable_set('miniorange_saml_idp_login_url', $saml_login_url);
				  variable_set('miniorange_saml_idp_x509_certificate', $saml_x509_certificate[0]);
				  
			}
			
				  drupal_set_message(t('Identity Provider Configuration successfully saved.'));
				return;
		} else {
					drupal_set_message(t('Please provide a valid metadata file.'),error);
					return;
		}	  
				
				
}
