<?php
/**
 * @file
 * Contains Login Settings for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
 function miniorange_saml_login_options($form, &$form_state) {

  if (variable_get('miniorange_saml_customer_admin_email', NULL) == NULL || variable_get('miniorange_saml_customer_id', NULL) == NULL
    || variable_get('miniorange_saml_customer_admin_token', NULL) == NULL|| variable_get('miniorange_saml_customer_api_key', NULL) == NULL) {
    $form['header'] = array(
      '#markup' => '<center><h3>You need to register with miniOrange before using this module.</h3></center>',
    );

    return $form;
  }

  global $base_url;

  $form['markup_1'] = array(
    '#markup' => '<h2>Sign in Settings</h2>',
  );

  $form['miniorange_saml_force_auth'] = array(
    '#type' => 'checkbox',
    '#title' => t('Protect website against anonymous access <b>[PREMIUM]</b>'),
    '#default_value' => variable_get('miniorange_saml_force_auth', ''),
	'#disabled' => TRUE,
  );

  $form['markup_2'] = array(
    '#markup' => '<b>Note: </b>Users will be redirected to your IdP for login in case user is not logged in and tries to access website.<br><br>',
  );

  $form['miniorange_saml_auto_redirect'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>auto redirect the user to IdP [PREMIUM]</b>'),
    '#default_value' => variable_get('miniorange_saml_auto_redirect_to_idp'),
	'#disabled' => TRUE,
  );

  $form['markup_3'] = array(
    '#markup' => '<b>Note: </b>Users will be redirected to your IdP for login when the login page is accessed.<br><br>',
  );

  $form['miniorange_saml_enable_backdoor'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to enable <b>backdoor login [PREMIUM]</b>'),
    '#default_value' => variable_get('miniorange_saml_enable_backdoor', ''),
	'#disabled' => TRUE,
  );

  $form['markup_4'] = array(
    '#markup' => '<b>Note: </b>Checking this option <b>creates a backdoor to login to your Website using Drupal credentials</b><br>' 
    . ' incase you get locked out of your IdP. Note down this URL: <b>' . $base_url . '/?saml_login=false</b><br><br>',
  );
 
  return $form;

 }
 function miniorange_saml_save_signin_settings($form, &$form_state) {

 	drupal_set_message(t('Signin Settings successfully saved'));

 }
