<?php
/**
 * @file
 * Contains Attribute and Role Mapping for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
 function miniorange_saml_mapping($form, &$form_state) {

  if (variable_get('miniorange_saml_customer_admin_email', NULL) == NULL || variable_get('miniorange_saml_customer_id', NULL) == NULL
    || variable_get('miniorange_saml_customer_admin_token', NULL) == NULL || variable_get('miniorange_saml_customer_api_key', NULL) == NULL) {
    $form['header'] = array(
      '#markup' => '<center><h3>You need to register with miniOrange before using this module.</h3></center>',
    );

    return $form;
  }
  
  global $base_url;
 
  $form['miniorange_saml_account_username_by'] = array(
    '#type' => 'select',
    '#title' => t('Login/Create Drupal account by'),
    '#options' => array(
      1 => t('Username'),
      2 => t('Email'),
    ),
    '#default_value' => variable_get('miniorange_saml_login_by'),
  );

  $form['miniorange_saml_username_attribute'] = array(
    '#type' => 'textfield',
    '#title' => t('Username Attribute'),
    '#default_value' => variable_get('miniorange_saml_username_attribute', 'NameID'),
    '#attributes' => array('placeholder' => 'Enter Username attribute'),
    '#required' => TRUE,
	'#disabled' => TRUE,
  );

  $form['miniorange_saml_email_attribute'] = array(
    '#type' => 'textfield',
    '#title' => t('Email Attribute'),
    '#default_value' => variable_get('miniorange_saml_email_attribute', 'NameID'),
    '#attributes' => array('placeholder' => 'Enter Email attribute'),
    '#required' => TRUE,
	'#disabled' => TRUE,
  );
  
$form['miniorange_saml_idp_attr1_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Role [PREMIUM]'),
	'#attributes' => array('placeholder' => 'Enter Role Attribute'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
 
  $form['markup_cam'] = array(
    '#markup' => '<h3>Custom Attribute Mapping [PREMIUM]</h3><p>Add the Drupal field attributes in the Attribute Name textfield and add the IdP attibutes that you need to map with the drupal attributes in the IdP Attribute Name textfield. Drupal Field Attributes will be of type text. Add the machine name of the attribute in the Drupal Attribute textfield.</p><p>For example: If the attribute name in the drupal is name then its machine name will be field_name.</p>',
  );
  
  $form['miniorange_disable_attribute'] = array(
    '#type' => 'checkbox',
    '#title' => t('Do not update existing user&#39;s role <b>[PREMIUM]</b>'),
	'#disabled' => TRUE,
  );
  
   $form['miniorange_saml_attr5_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 1'),
	'#default_value' => variable_get('miniorange_saml_attr5_name', ''),
	'#attributes' => array('placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr5_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 1'),
	'#default_value' => variable_get('miniorange_saml_idp_attr5_name', ''),
	'#attributes' => array('placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr2_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 2'),
	'#default_value' => variable_get('miniorange_saml_attr2_name', ''),
	'#attributes' => array('placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr2_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 2'),
	'#default_value' => variable_get('miniorange_saml_idp_attr2_name', ''),
	'#attributes' => array('placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr3_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 3'),
	'#default_value' => variable_get('miniorange_saml_attr3_name', ''),
	'#attributes' => array('placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr3_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 3'),
	'#default_value' => variable_get('miniorange_saml_idp_attr3_name', ''),
	'#attributes' => array('placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr4_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 4'),
	'#default_value' => variable_get('miniorange_saml_attr4_name', ''),
	'#attributes' => array('placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr4_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 4'),
	'#default_value' => variable_get('miniorange_saml_idp_attr4_name', ''),
	'#attributes' => array('placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
   $form['markup_role'] = array(
    '#markup' => '<h3>Custom Role Mapping</h3>',
  );
  
   $form['miniorange_saml_enable_rolemapping'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>enable Role Mapping</b>'),
    '#default_value' => variable_get('miniorange_saml_enable_rolemapping'),
  );
  
   $form['miniorange_saml_disable_role_update'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you do not want to update user role if roles not mapped. <b>[PREMIUM]</b>'),
	'#disabled' => TRUE,
  );  
  
   $form['miniorange_saml_disable_autocreate_users'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to disable <b>auto creation</b> of users if user does not exist. <b>[PREMIUM]</b>'),
    '#default_value' => variable_get('miniorange_saml_disable_autocreate_users', ''),
	'#disabled' => TRUE,
  );
  
	$mrole= user_roles($membersonly = TRUE);
	$drole = array_search(variable_get('miniorange_saml_default_role',''),$mrole);
  
   $form['miniorange_saml_default_mapping'] = array(
    '#type' => 'select',
	'#title' => t('Select default group for the new users'),
	'#options' => $mrole,
	'#default_value' => $drole,
   );
    
	foreach($mrole as $roles) {
    $rolelabel = str_replace(' ','',$roles);
    $form['miniorange_saml_role_' . $rolelabel] = array(
	'#type' => 'textfield',
	'#title' => t($roles),
	'#default_value' => variable_get('miniorange_saml_role_' . $rolelabel, ''),
	'#attributes' => array('placeholder' => 'Semi-colon(;) separated Group/Role value for ' . $roles),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  }
  
   $form['markup_role_signin'] = array(
    '#markup' => '<h3>Custom Login/Logout (Optional) [PREMIUM]</h3>'
  );
  
	foreach($mrole as $drupalKey=>$drupalRoles) {
		
		$lbl = str_replace(' ','',$drupalRoles . '_sin');
		$l= str_replace(' ','',$drupalRoles . '_sout');
	
		$form[$lbl] = array(
			'#type' => 'textfield',
			'#title' => $drupalRoles,
			'#default_value' => variable_get($lbl, ''),
			'#attributes' => array('placeholder' => 'Enter Login URL'),
			'#required' => FALSE,
			'#disabled' => TRUE,
		 );

		$form[$l] = array(
			'#type' => 'textfield',
			'#default_value' => variable_get($l, ''),
			'#attributes' => array('placeholder' => 'Enter Logout URL'),
			'#required' => FALSE,
			'#disabled' => TRUE,
		 );
	
	}
	
  $form['miniorange_saml_gateway_config_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Configuration'),
    '#submit' => array('miniorange_saml_save_mapping_settings'),
  );
  return $form;

 }
 
  function miniorange_saml_save_mapping_settings($form, &$form_state) {
  
  $enable_rolemapping = $form['miniorange_saml_enable_rolemapping']['#value'];
 
  
  $mrole= user_roles($membersonly = TRUE);	
  $login_by = $form['miniorange_saml_account_username_by']['#value'];
  $username_attribute = $form['miniorange_saml_username_attribute']['#value'];
  $email_attribute = $form['miniorange_saml_email_attribute']['#value'];
  $default_mapping= $form['miniorange_saml_default_mapping']['#value'];
 	
	if($enable_rolemapping == 1) {
		$enable_rolemapping = TRUE;
	}
	else {
		$enable_rolemapping = FALSE;
	}
  
  variable_set('miniorange_saml_enable_rolemapping', $enable_rolemapping);
  if($enable_rolemapping) {
  
		variable_set('miniorange_saml_default_role', $mrole[$default_mapping]);
    }
  
  else {
  
		variable_set('miniorange_saml_default_role', $mrole[2]);
    }
  variable_set('miniorange_saml_login_by', $login_by);
  variable_set('miniorange_saml_username_attribute', $username_attribute);
  variable_set('miniorange_saml_email_attribute', $email_attribute);
  	
  drupal_set_message(t('Signin Settings successfully saved'));

  }