<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

 /**
 * Showing IdP Setup form info.
 */
 function miniorange_saml_proxy_setup($form, &$form_state) {

  $form['header1'] = array(
    '#markup' => '<h3>Configure Proxy Server</h3>',
  ); 
  
  $form['header2'] = array(
    '#markup' => 'Enter the information to setup the proxy server.',
  ); 
  
  $form['miniorange_saml_proxy_host'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy Host Name'),
    '#default_value' => variable_get('miniorange_saml_proxy_host', ''),
    '#attributes' => array('placeholder' => 'Enter the host name'),
  );
  
  $form['miniorange_saml_proxy_port'] = array(
    '#type' => 'textfield',
    '#title' => t('Port Number'),
    '#default_value' => variable_get('miniorange_saml_proxy_port', ''),
    '#attributes' => array('placeholder' => 'Enter the port number of the proxy'),
  );
  
  $form['miniorange_saml_proxy_username'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy Username'),
    '#default_value' => variable_get('miniorange_saml_proxy_username', ''),
    '#attributes' => array('placeholder' => 'Enter the username of the proxy server'),
  );
  
  $form['miniorange_saml_proxy_password'] = array(
    '#type' => 'password',
    '#title' => t('Password'),
    '#default_value' => variable_get('miniorange_saml_proxy_password', ''),
    '#attributes' => array('placeholder' => 'Enter the password of the poxy server'),
  );

  $form['miniorange_saml_proxy_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('miniorange_saml_save_proxy'),
  );
  
  return $form;

 }

 /**
 * Configure Proxy Server.
 */

function miniorange_saml_save_proxy($form, &$form_state) {
  
  $proxy_host = $form['miniorange_saml_proxy_host']['#value'];
  $port_number = $form['miniorange_saml_proxy_port']['#value'];
  $proxy_username = $form['miniorange_saml_proxy_username']['#value'];
  $proxy_password = $form['miniorange_saml_proxy_password']['#value'];

  variable_set('miniorange_saml_proxy_host',$proxy_host);
  variable_set('miniorange_saml_proxy_port',$port_number);
  variable_set('miniorange_saml_proxy_username',$proxy_username);
  variable_set('miniorange_saml_proxy_password',$proxy_password );
  
  // var_dump(variable_get('miniorange_saml_proxy_password')); exit;
  
  drupal_set_message(t('Your configuration has been saved successfully.'));

}
