<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

 /**
 * Showing Service Provider information.
 */
 function miniorange_sp_information($form, &$form_state) {

  if (variable_get('miniorange_saml_customer_admin_email', NULL) == NULL || variable_get('miniorange_saml_customer_id', NULL) == NULL
    || variable_get('miniorange_saml_customer_admin_token', NULL) == NULL|| variable_get('miniorange_saml_customer_api_key', NULL) == NULL) {
    $form['header'] = array(
      '#markup' => '<center><h3>You need to register with miniOrange before using this module.</h3></center>',
    );

    return $form;
  }

  drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
  drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
    
   global $base_url;
   $acs_url = $base_url . '/?q=samlassertion';

   $module_path = drupal_get_path('module', 'miniorange_saml');
   
   $form['miniorange_base_url'] = array(
    '#type' => 'textfield',
    '#title' => t('SP Base URL: [PREMIUM]'),
    '#default_value' => $base_url,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_issuer'] = array(
    '#type' => 'textfield',
    '#title' => t('SP EntityID / Issuer: [PREMIUM]'),
    '#default_value' => $base_url,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_default_relaystate'] = array(
    '#type' => 'textfield',
    '#title' => t('Default Redirect URL after login [PREMIUM]'),
    '#default_value' => $base_url,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_save'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_1'] = array(
	'#markup' => '<form><br>'
	
.'<input type="radio" id="mo_saml_enable_cloud_broker" name="mo_saml_enable_cloud_broker" value="miniorange" onchange="display(this);" />Use miniOrange as an Identity Provider (IDP) ( <a href="#mo_idp" onclick="altdisplay(this);">Click Here</a> to know how the plugin works for this case. )<br/>'

.'<input type="radio" id="mo_saml_enable_cloud_broker" name="mo_saml_enable_cloud_broker" value="true" onchange="display(this);" />Use miniOrange Identity broker service. (<a href="#mo_b_service" onclick="altdisplay(this);">Click Here</a> to know how the plugin works for this case. )<br/>'

.'<input type="radio" id="mo_saml_enable_cloud_broker" name="mo_saml_enable_cloud_broker" value="false" checked="checked" onchange	="display(this);" />Use Your own Identity Provider ( <a href="#other_idp" onclick="altdisplay(this);">Click Here</a> to know how the plugin works for this case. )<br/>'
.'</form>'

.'<div id="mo_idp" style="display:none;">'
.'<h3>Use miniOrange Identity broker service:</h3>'
.'<div style="display:block;text-align:center;">'
.'<img src="'. $base_url . '/' . $module_path . '/includes/images/drupalmo.png" alt="Working of miniOrange SAML plugin" style="width:30%;"/>'
.'</div>'
.'<ol>'
.'<li>miniOrange SAML SSO plugin sends a login request to MiniOrange for authentication.</li>'
.'<li>Upon successful authentication, MiniOrange sends a SAML Response back to miniOrange SAML SSO plugin. Plugin then reads the response and login the user.</li>'
.'</ol>'
.'<b>Advantages:</b>'
.'<ol>'
.'<li>The number of messages required for Single Sign On is less as your website is directly interacting with the Identity Provider.</li>'
.'</ol>'
.'</div>'

.'<div id="mo_b_service" style="display:none;">'
.'<h3>Use miniOrange Identity broker service:</h3>'
.'<div style="display:block;text-align:center;">'
.'<img src="'. $base_url . '/' . $module_path . '/includes/images/saml_working.png" alt="Working of miniOrange SAML plugin" style="width: 50%;"/>'
.'</div>'
.'<ol>'
.'	<li>miniOrange SAML SSO plugin sends a login request to miniOrange SSO Service.</li>'
.'	<li>miniOrange SSO Service creates a SAML Request and redirects the user to your Identity Provider for authentication.</li>'
.'	<li>Upon successful authentication, your Identity Provider sends a SAML Response back to miniOrange SSO Service.</li>'
.'	<li>miniOrange SSO Service verifies the SAML Response and sends a response status (along with the logged in user&#39;s information) back to miniOrange SAML SSO plugin. Plugin then reads the response and logins the user.</li>'
.'</ol>'
.'<div>'
.'	<b>Advantages:</b>'
.'	<ol>'
.'		<li>If you are an enterprise or business user then on using this service you will be able to take full advantage of all of miniOrange SSO features. ( For a complete list of these features <a href="http://miniorange.com/single-sign-on-sso" target="_blank">Click Here</a>)</li>'
.'		<li>You can use Non-SAML Identity Providers for Single Sign On.</li>'
.'		<li>If you have multiple websites then you can use the same IdP configuration for all of them. You don&#39;t have to make seperate configurations in your IdP.</li>'
.'		<li>Some Identity Providers like ADFS do not support HTTP endpoints ( i.e. your Drupal site needs to be on HTTPS ). So, if your Drupal site is not on HTTPS then you can use this service for such IdPs.</li>'
.'	</ol>'

.'</div>'
.'</div>'

.'<div id="other_idp" style="display:none;">'
.'								<h3>Use Your own Identity Provider:</h3>'
.'								<div style="display:block;text-align:center;">'
.'								<img src="'. $base_url . '/' . $module_path . '/includes/images/saml_working_womo.png" alt="Working of miniOrange SAML plugin" style="width: 35%;"/>'
.'								</div>'
.'								<ol>'
.'									<li>miniOrange SAML SSO plugin sends a login request to your Identity Provider for authentication.</li>'
.'									<li>Upon successful authentication, your Identity Provider sends a SAML Response back to miniOrange SAML SSO plugin. Plugin then reads the response and login the user.</li>'
.'								</ol>'

.'								<div>'
.'									<b>Advantages:</b>'
.'									<ol>'
.'										<li>The number of messages required for Single Sign On is less as your website is directly interacting with the Identity Provider.</li>'
.'									</ol>'
.'								</div>'
.'							</div>'


.'<div id="mo_miniorange_idp" style="display:none">',
);

 $form['header_mo_idp'] = array(
    '#markup' => '<center><h3>You will need the following information to'
    . ' configure your IdP. Copy it and keep it handy</h3></center>',
  );

  $header_mo_idp = array(
    'attribute' => array('data' => t('Attribute')),
    'value' => array('data' => t('Value')),
  );

  $options_mo_idp = array();

  $options_mo_idp[0] = array(
    'attribute' => t('Issuer'),
    'value' => $base_url,
  );

  $options_mo_idp[1] = array(
    'attribute' => t('ACS URL'),
    'value' => $acs_url,
  );

  $form['fieldset1']['spinfo_mo'] = array(
    '#theme' => 'table',
    '#header' => $header_mo_idp,
    '#rows' => $options_mo_idp,
  );

$form['miniorange_saml_2'] = array(
'#markup' => '<br><a href="' . $base_url . '/' . $module_path . '/idp_guides/miniorange_as_idp.pdf" target="_blank">Click Here to see the Guide for Configuring miniOrange as IdP. </a><br>'
.'</div>'
.'<div id="mo_miniorange_broker" style="display:none">',
);

$form['header_mo_broker'] = array(
    '#markup' => '<center><h3>You will need the following information to'
    . ' configure your IdP. Copy it and keep it handy</h3></center>',
  );

  $header_mo_broker = array(
    'attribute' => array('data' => t('Attribute')),
    'value' => array('data' => t('Value')),
  );

  $options_mo_broker = array();

  $options_mo_broker[0] = array(
    'attribute' => t('SP-EntityID / Issuer'),
    'value' => 'https://auth.miniorange.com/moas',
  );

  $options_mo_broker[1] = array(
    'attribute' => t('ACS (AssertionConsumerService) URL / Single Sign-On URL (SSO)'),
    'value' => 'https://auth.miniorange.com/moas/rest/saml/acs',
  );

  $options_mo_broker[2] = array(
    'attribute' => t('Single Logout URL (SLO)'),
    'value' => 'Available in the <b>Premium</b> version',
  );

  $options_mo_broker[3] = array(
    'attribute' => t('Audience URI'),
    'value' => 'https://auth.miniorange.com/moas',
  );

  $options_mo_broker[4] = array(
    'attribute' => t('NameID Format'),
    'value' => 'urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress',
  );

  $options_mo_broker[5] = array(
    'attribute' => t('Default Relay State (Optional)'),
    'value' => 'Available in the <b>Premium</b> version',
  );

  $form['fieldset_mo_broker']['spinfo_mo_broker'] = array(
    '#theme' => 'table',
    '#header' => $header_mo_broker,
    '#rows' => $options_mo_broker,
  );

  $form['miniorange_saml_3'] = array(
'#markup' => '<p><h3 align="center">OR</h3></p><code style="background-color:gainsboro;"><b> Provide Metadata URL to your Identity Provider: ' 
.'<a href="https://auth.miniorange.com/moas/metadata/sp-metadata.xml" id="metadata-link" target="_blank">https://auth.miniorange.com/moas/metadata/sp-metadata.xml</a>'
.'</code>'

.'</div>'
.'<div id="mo_other_idp">',
 ); 
   
  $form['header'] = array(
    '#markup' => '<center><h3>You will need the following information to'
    . ' configure your IdP. Copy it and keep it handy</h3></center>',
  );

  $header = array(
    'attribute' => array('data' => t('Attribute')),
    'value' => array('data' => t('Value')),
  );

  $options = array();

  $options[0] = array(
    'attribute' => t('Issuer'),
    'value' => $base_url,
  );

  $options[1] = array(
    'attribute' => t('ACS URL'),
    'value' => $acs_url,
  );

  $options[2] = array(
    'attribute' => t('Audience URI'),
    'value' => $base_url,
  );

  $options[3] = array(
    'attribute' => t('Recipient URL'),
    'value' => $acs_url,
  );

  $options[4] = array(
    'attribute' => t('Destination URL'),
    'value' => $acs_url,
  );

  $options[5] = array(
    'attribute' => t('NameID Format'),
    'value' => 'urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress',
  );

  $form['fieldset']['spinfo'] = array(
    '#theme' => 'table',
    '#header' => $header,
    '#rows' => $options,
  );

  $form['markupsp_sp_md_2'] = array(
    '#markup' => '<p><h3 align="center">OR</h3></p><code style="background-color:gainsboro;"><b> Provide Metadata URL to your Identity Provider: '
	. '<a target="_blank" href="' .  $base_url . '/' . $module_path . '/includes/metadata/metadata.php">' .  $base_url . '/' . $module_path . '/includes/metadata/metadata.php' . '</a></b></code>'
	.'</div>',
  );

  $form['markup_doc'] = array(
    '#markup' => '<br><br><a target="_blank" href="https://www.miniorange.com/drupal-saml-single-sign-on-(sso)">Click here</a> for a detailed documentation of the plugin.',
  );
  
  $form['markup_13'] = array(
    '#markup' => '<h3>Identity Provider Guides</h3>',
  );

  $form['markup_14'] = array(
    '#markup' => 'With the help of the above information, you can configure your IdP. We also have guides for configuring various IdP\'s<br>',
  );

  $form['markup_15'] = array(
    '#markup' => '<b>NOTE: </b> We also have step by step do-it-yourself guides available for all known IdPs like ADFS, Centrify, Okta, '
    . 'OneLogin, OpenAM, Oracle Identity Manager, JBoss Keycloak, Salesforce, Shibboleth, SimpleSAML, WSO2 etc. <b>[PREMIUM]</b>',
  );

  return $form;
 }
